#!/usr/bin/env python3

import signal, subprocess, sys
import re, json

def find_forward( name ):
    cmd = "dig " + str( name )
    sp = subprocess.Popen(cmd, shell=True,
                          stdout=subprocess.PIPE,
                          stderr=subprocess.STDOUT, close_fds=True)
    ip = None
    for line in sp.stdout:
        line = line.strip( ).decode("utf-8")
        #                                1
        match = re.search( "^"+name+".*IN\s+A\s+([^\s]+)$", line )
        if match:
            ip = match.group( 1 )

    exit_code = sp.wait( )
    if exit_code == None:
        exit_code = 0
    else:
        exit_code = (exit_code >> 8) & 0xFF
    if exit_code != 0:
        ip = "ERROR in command"
        
    return ip

def find_reverse( ip ):
    cmd = "dig -x " + str( ip )
    sp = subprocess.Popen(cmd, shell=True,
                          stdout=subprocess.PIPE,
                          stderr=subprocess.STDOUT, close_fds=True)
    name = None
    for line in sp.stdout:
        line = line.strip( ).decode("utf-8")
        #                                1
        match = re.search( "PTR[ \t\n\r]*([^ \t\n\r]+)$", line )
        if match:
            name = match.group( 1 )

    exit_code = sp.wait( )
    if exit_code == None:
        exit_code = 0
    else:
        exit_code = (exit_code >> 8) & 0xFF
    if exit_code != 0:
        name = "ERROR in command"
        
    return name

def check_ips_dns( ip, db ):
    reverse_name = find_reverse( ip )
    if reverse_name is not None:
        forward_ip = find_forward( reverse_name )
    else:
        forward_ip = None
    db[ ip ] = ( reverse_name, forward_ip )
    if forward_ip == ip:
        return True
    else:
        return False

def check_ip_range( ip_base, first, last ):
    db = { }
    for i in range( int(first), int(last)+1 ):
        ip = str( ip_base ) + "." + str( i )
        if check_ips_dns( ip, db ):
            print( ip, "is ok." )
        else:
            print( ip, "is NOT ok." )
            print( db[ ip ] )

    f = open( "data_file.json", "w" )
    f.write( json.dumps( db ) )
    f.close()

    f = open( "data_file.json", "r" )
    s = "".join( f.readlines() )
    f.close( )
    db_back = json.loads( s )
    print( db_back )
    return

check_ip_range( "144.38.209", 224, 255 )

